<?php
$title = _("Edit Election");
headers(array('title'=>$title,'menu'=>1,
	      'head_extras'=>'<script type="text/javascript" src="lib/popupcalendar/calendar.js"></script>',
	      )
	);

if(!has_permission(get_member_id($_SESSION['user']),'election admin')) {
  ?>
  <div class="error">
    <p><?=_('You do not have permission to do this.')?></p>
  </div>
<?php
  exit();
}

$edit_election= $_GET['id'] + 0;


if($edit_election && !$_POST) {
  global $dbh;
  // we have an id we're going to edit, get the data from the database.
  // We get into $_POST as then the forms infrastructure takes care
  // of a bunch of stuff for us
  $row = sql_select('election','id='.$dbh->quote($_GET['id']));
  $_POST['name'] = $row->name;
  $_POST['desc'] = $row->description;
  $_POST['num_req_nominations'] = $row->num_req_nominations;
  $_POST['start_advertising_date'] = date("d/m/Y",
					  strtotime($row->start_advertising));
  $_POST['start_advertising_time'] = date("H:i",
					  strtotime($row->start_advertising));
  $_POST['start_nominations_date'] = date("d/m/Y",
					  strtotime($row->nominations_start));
  $_POST['start_nominations_time'] = date("H:i",
					  strtotime($row->nominations_start));
  $_POST['close_nominations_date'] = date("d/m/Y",
					  strtotime($row->nominations_close));
  $_POST['close_nominations_time'] = date("H:i",
					  strtotime($row->nominations_close));
  $_POST['advertise_candidates_date'] = date("d/m/Y",
					strtotime($row->advertise_candidates));
  $_POST['advertise_candidates_time'] = date("H:i",
					strtotime($row->advertise_candidates));
  $_POST['live_results'] = $row->live_results;
  $_POST['start_voting_date'] = date("d/m/Y",strtotime($row->start_voting));
  $_POST['start_voting_time'] = date("H:i",strtotime($row->start_voting));
  $_POST['close_voting_date'] = date("d/m/Y",strtotime($row->close_voting));
  $_POST['close_voting_time'] = date("H:i",strtotime($row->close_voting));
  $_POST['show_results_date'] = date("d/m/Y",strtotime($row->show_results));
  $_POST['show_results_time'] = date("H:i",strtotime($row->show_results));
  $sql = "select * from election_position where election_id=".
    $dbh->quote($_GET['id']);
  $result = $dbh->query($sql);
  for($i=0;$row = $result->fetchrow(DB_FETCHMODE_OBJECT);$i++) {
    eval("\$_POST['position".($i?$i:'0')."_name'] = '".$row->name."';");
    eval("\$_POST['position".($i?$i:'0')."_num'] = '".$row->num."';");
    eval("\$_POST['position".($i?$i:'0')."_desc'] = '".$row->description."';");
  }
  $_POST['nrpositions']=$i;
}

function datetime_formitem($title,$name,$desc) {
  return array('type'=>'fieldset',
	       'legend'=>$title,
	       'fields'=>
	       array($name.'desc'=>array('type'=>'html',
				    'html'=>$desc),
		     $name.'_date'=>
		     array('label'=>_('Date'),
			   'required'=>1,
			   'type'=>'date',
			   'default'=>date("d/m/Y"),
			   'valid'=>array(
					  'preg_match("/\w+/", $val)'
					  =>_('Must have a date')
					  ),
			   ),
		     $name.'_time'=>
		     array('label'=>_('Time'),
			   'required'=>1,
			   'type'=>'text',
			   'default'=>date("H:i"),
			   'valid'=>array(
					  '$a = split(":",$val); return $a[0]>=0 && $a[0]<24 && $a[1]>=0 && $a[1]<60;'=>_('Not a valid time')),
			   ),
		     ),
	       );
  
}

$electionform =
array('general'=>array('type'=>'fieldset',
		       'legend'=>_('Election Information'),
      'fields'=>array(
	     'name'=>array('type'=>'text',
			   'label'=>_('Name'),
			   'maxlength'=>50,
			   'required'=>1,
			   'valid'=>array(
					  'preg_match("/\w+/", $val)'
					  =>_('Must enter a name for the election')
					  ),
			   ),
	     'for'=>array('label'   =>_('For'),
			  'type'    =>'select',
			  'options' =>array(_('This Organisation'),_('Any Organisation')),
			  ),
	     'num_req_nominations'=>array(
					  'type'=>'text',
					  'label'=>_('Number of requried nominations'),
					  'maxlength'=>5,
					  'default'=>2,
					  'valid'=>array(
							 '$val >= 0'=>
							 _('Must be a number >= 0')
							 ),
					  ),
	     'desc'=>array('type'=>'textarea',
			   'label'=>_('Description'),
			   'title'=>_('Description of this election'),
			   'rows'=>5,
			   'cols'=>40,
			   ),
	     'start_advertising'=>datetime_formitem(_("Start Advertising"),
						    'start_advertising',
						    '<p>'._('Date and time from which people can see that the election exists.').'</p>'),
	     'start_nominations'=>datetime_formitem(_("Start Nominations"),
						    'start_nominations',
						    '<p>'._('Date and time where people can nominate others for positions.').'</p>'),
	     'close_nominations'=>datetime_formitem(_("End Nominations"),
						    'close_nominations',
						    '<p>'._('When the nomination period closes.').'</p>'),
	     'advertise_candidates'=>datetime_formitem(_("Advertise Candidates"),
						       'advertise_candidates',
						       '<p>'._('When a list of candidates (accepted nominees) are available for viewing.').'</p>'),
	     'start_voting'=>datetime_formitem(_("Start Voting"),'start_voting',
					       '<p>'._('When voting starts').'</p>'),
	     'close_voting'=>datetime_formitem(_("Close Voting"),'close_voting',
					       '<p>'._('When voting closes').'</p>'),
	     'show_results'=>datetime_formitem(_("Show Results"),'show_results',
					       '<p>'._('When the results are visible.').'</p>'),
	     'live_results'=>array('type'=>'checkbox',
				   'label'=>_('Show Live Results')),
	     )
		       )
      );

      // Add another position if asked
if($_POST['more_positions']==_('Add Position'))
  $_POST['nrpositions']++;

  // never allow < 0 positions
if($_POST['nrpositions']<0)
  $_POST['nrpositions']=0;

  // Sane default
if(!isset($_POST['nrpositions']))
  $_POST['nrpositions']=1;

  // Check if we're removing any
foreach(array_keys($_POST) as $item) {
  if(preg_match('/^position(\d+)_delete$/',$item,$matches)) {
    // if so, move all the data down.
    // We manipulate $_POST here as there is no use duplicating data.
    for($i=$match[0];$i<$_POST['nrpositions'];$i++) {
      eval("\$_POST['position".($i?$i:'0')."_name'] = \$_POST['position".($i+1)."_name'];");
      eval("\$_POST['position".($i?$i:'0')."_desc'] = \$_POST['position".($i+1)."_desc'];");
      eval("\$_POST['position".($i?$i:'0')."_num'] = \$_POST['position".($i+1)."_num'];");
    }
    $_POST['nrpositions']--;
  }
}

$electionform+= array('nrpositions'=>array('type'=>'hidden',
					   'default'=>1,),
		      'more_positions'=>array('type'=>'button',
					      'label'=>_('Add Position')),
		      );

for($i=0;$i<$_POST['nrpositions'];$i++) {
  $electionform+= array('position'.$i=>array('type'=>'fieldset',
					     'legend'=>_('Position ').($i+1),
					     'fields'=>
					     array(
		        'position'.$i.'_name'=>array('type'=>'text',
						     'required'=>1,
						     'maxlength'=>50,
						     'label'=>_('Name'),
						     'valid'=>array(
					  'preg_match("/\w+/", $val)'
					  =>_('Must enter a name for the position')
					  ),
						     ),
			'position'.$i.'_num'=>array('type'=>'text',
						    'label'=>_('Number'),
						    'maxlength'=>5,
						    'default'=>1,
						    'valid'=>array(
								   '$val>0'=>_('Must be a number &gt; 0')
					  ),
						    ),
		        'position'.$i.'_desc'=>array('type'=>'textarea',
						     'label'=>_('Description'),
						     'cols'=>40,
						     'rows'=>5,
						     'title'=>_('Position Description')
						     ),
			'position'.$i.'_delete'=>array('type'=>'button',
						       'label'=>_('Remove')),
			),
					     ),
			);
}

/* pass $_POST as we have manipulated it previously (i.e. it is now
 * different to $HTTP_POST_VARS due to the whole PHP references crap.
 */
$errors = validate($electionform, $_POST);

if(!$errors && isset($_POST['edit_election']))
{
  if($edit_election)
  {
    global $dbh,$config;
    $err = $dbh->autoCommit(false);
    if($err!=DB_OK) {
      my_syslog(LOG_ERR,"Error while disabling autoCommit: $err,".
		var_export($err));
      echo '<p class="error">Internal database error, please report this';
      echo ' to the webmaster</p>.';
      exit(0);
    }
    $dbh->query("begin");
    $election_id= $_GET['id']+0;
    sql_update('election',
	       array('name'=>$_POST['name'],
		     'org_id'=>($_POST['for']==_('This Organisation'))
		     ?$config['org_id'] : 'NULL',
		     'num_req_nominations'=>$_POST['num_req_nominations'],
		     'description'=>$_POST['desc'],

		     'start_advertising'=>
		     date("Y-m-d H:i", my_strtotime($_POST['start_advertising_date'])).' '.date("H:i",strtotime($_POST['start_advertising_time'])),

		     'nominations_start'=>
		     date("Y-m-d H:i", my_strtotime($_POST['start_nominations_date'])).' '.date("H:i",strtotime($_POST['start_nominations_time'])),

		     'nominations_close'=>
		     date("Y-m-d H:i", my_strtotime($_POST['close_nominations_date'])).' '.date("H:i",strtotime($_POST['close_nominations_time'])),

		     'advertise_candidates'=>
		     date("Y-m-d H:i", my_strtotime($_POST['advertise_candidates_date'])).' '.date("H:i",strtotime($_POST['advertise_candidates_time'])),

		     'live_results'=>$_POST['live_results'],

		     'start_voting'=>
		     date("Y-m-d H:i", my_strtotime($_POST['start_voting_date'])).' '.date("H:i",strtotime($_POST['start_voting_time'])),

		     'close_voting'=>
		     date("Y-m-d H:i", my_strtotime($_POST['close_voting_date'])).' '.date("H:i",strtotime($_POST['close_voting_time'])),

		     'show_results'=>
		     date("Y-m-d H:i", my_strtotime($_POST['show_results_date'])).' '.date("H:i",strtotime($_POST['show_results_time'])),
		     ),
	       'id='.$dbh->quote($election_id)
	       );
/*    for($i=0;$i<$_POST['nrpositions'];$i++) {
      sql_insert('election_position',
		 array('election_id'=>$election->id,
		       'name'=>eval("return \$_POST['position".($i?$i:'0')."_name'];"),
		       'num'=>eval("return \$_POST['position".($i?$i:'0')."_num'];"),
		       'description'=>eval("return \$_POST['position".($i?$i:'0')."_desc'];"),
		       )
		       );*/
    if($dbh->commit()) {
      echo '<p>';
      printf (_('Election has been edited. You can %scontinue to edit%s it.'),
	      '<a href="'.$PHP_SELF.'?page=edit-election&id='.$election_id.'">',
	      '</a>');
      echo '</p>';
    } else {
      echo '<p class="error">'._('There was an error editing the election.').'</p>';
    }
  }
  else
  {
    // We have a valid form, and have been asked to apply it
    global $dbh,$config;
    $err = $dbh->autoCommit(false);
    if($err!=DB_OK) {
      my_syslog(LOG_ERR,"Error while disabling autoCommit: $err,".
		var_export($err));
      echo '<p class="error">Internal database error, please report this';
      echo ' to the webmaster</p>.';
      exit(0);
    }
    $dbh->query("begin");
    sql_insert('election',
	       array('name'=>$_POST['name'],
		     'org_id'=>($_POST['for']=='This Organisation')?$config['org_id'] : 'NULL',
		     'num_req_nominations'=>$_POST['num_req_nominations'],
		     'description'=>$_POST['desc'],

		     'start_advertising'=>
		     date("Y-m-d H:i", my_strtotime($_POST['start_advertising_date'])).' '.date("H:i",strtotime($_POST['start_advertising_time'])),

		     'nominations_start'=>
		     date("Y-m-d H:i", my_strtotime($_POST['start_nominations_date'])).' '.date("H:i",strtotime($_POST['start_nominations_time'])),

		     'nominations_close'=>
		     date("Y-m-d H:i", my_strtotime($_POST['close_nominations_date'])).' '.date("H:i",strtotime($_POST['close_nominations_time'])),

		     'advertise_candidates'=>
		     date("Y-m-d H:i", my_strtotime($_POST['advertise_candidates_date'])).' '.date("H:i",strtotime($_POST['advertise_candidates_time'])),

		     'live_results'=>$_POST['live_results'],

		     'start_voting'=>
		     date("Y-m-d H:i", my_strtotime($_POST['start_voting_date'])).' '.date("H:i",strtotime($_POST['start_voting_time'])),

		     'close_voting'=>
		     date("Y-m-d H:i", my_strtotime($_POST['close_voting_date'])).' '.date("H:i",strtotime($_POST['close_voting_time'])),

		     'show_results'=>
		     date("Y-m-d H:i", my_strtotime($_POST['show_results_date'])).' '.date("H:i",strtotime($_POST['show_results_time'])),
		     )
	       );
    $electionq = $dbh->query("select LAST_INSERT_ID() as id");
    $election = $electionq->fetchrow(DB_FETCHMODE_OBJECT);
    for($i=0;$i<$_POST['nrpositions'];$i++) {
      sql_insert('election_position',
		 array('election_id'=>$election->id,
		       'name'=>eval("return \$_POST['position".($i?$i:'0')."_name'];"),
		       'num'=>eval("return \$_POST['position".($i?$i:'0')."_num'];"),
		       'description'=>eval("return \$_POST['position".($i?$i:'0')."_desc'];"),
		       )
		 );
    }
    if($dbh->commit()) {
      echo '<p>';
      printf (_('Election has been added. You can %scontinue to edit%s it.'),
	      '<a href="'.$PHP_SELF.'?page=edit-election&id='.$election_id.'">',
	      '</a>');
      echo '</p>';
    } else {
      echo '<p class="error">'._('There was an error editing the election.').'</p>';
    }
  }
} else {
  echo '<div class="stdform">';
  print $errors;
  output_form($electionform,"edit_election",_("Save"),"post",($_GET['id'])?'&id='.($_GET['id']+0):'');
  echo '</div>';
}
?>

