<?php
$title = _("Edit Member Details");
headers(array('title'=>$title,'menu'=>1));

if($_GET['id']
   && has_permission(get_member_id($_SESSION['user']),'edit org_members')) {
  $member = get_member($_GET['id'],'members');
} else {
  if($_GET['id']) {?>
  <div class="error">
      <p><?=_('You do not have adequate permissions to edit the details of this member.')?></p>
  </div>
  <?php
    $member = NULL; // Don't go editing anyone if we don't have permission
  } else {
    // default to self
    $member = get_member(get_member_id($_SESSION['user']));
  }
}

include 'forms/member.inc';

if($member) {
echo '<div class="stdform">';

echo '<h2>'._('Edit Details for member #').$member->id.'</h2>';

$errors = validate($form_editmember, $HTTP_POST_VARS);

if(!$errors
   and strtolower($_SERVER['REQUEST_METHOD']) == 'post'
   and isset($_POST['edit-member'])) {
  if($_POST['sex']==_('Male'))
    $sexval = 'M';
  else if ($_POST['sex']==_('Female'))
    $sexval = 'F';
  else
    $sexval = ' ';

  $dbh->query("insert into members_old_details select * from members where "
	      ."id=".$member->id);

  sql_update('members',array(
			     'date_entered'=> date('Y-m-d H:i:s'),
			     'first_name'  => $_POST['first_name'],
			     'middle_name' => $_POST['middle_name'],
			     'last_name'   => $_POST['last_name'],
			     'dob'         => $_POST['dob'],
			     'sex'         => $sexval,
			     'address1'    => $_POST['address1'],
			     'address2'    => $_POST['address2'],
			     'suburb'      => $_POST['suburb'],
			     'postcode'    => $_POST['postcode'],
			     'state'       => $_POST['state'],
			     'country'     => $_POST['country'],
			     'email'       => $_POST['email'],
			     'phone_home'  => $_POST['phone_home'],
			     'phone_mobile'=> $_POST['phone_mobile']
			     ),
	     "id=".$member->id
	     );
  print '<p>'._('Successfully updated.').'</p>';
}

print $errors;
output_form($form_editmember,"edit-member",
	    _("Submit"),"post",
	    ($_GET['id'])?"&id=".$member->id:'');

echo '</div>';
?>
<table class="sortable" id="memberships_list">
<thead>
<tr>
   <th><?=_('Type')?></th>
   <th><?=_('Description')?></th>
   <th><?=_('Start')?></th>
   <th><?=_('Expiry')?></th>
   <th><?=_('Validates Membership')?></th>
   <th><?=_('Revokes Membership')?></th>
</tr>
</thead>
<tbody>
<?php
$sql= "select  * from org_memberships where member_id=".$member->id.
   " and org_id=".$config['org_id'].
   " order by validates_membership desc,start_date desc";
$result= $dbh->query($sql);
while($row = $result->fetchrow(DB_FETCHMODE_OBJECT)) {
  ?>
<tr>
<td><?=htmlise($row->type)?></td>
<td><?=htmlise($row->description)?></td>
<td><?=($row->start_date)?
   htmlise(date("d/m/Y",strtotime($row->start_date)))
   :
  "Never"?></td>
<td><?=($row->expiry)?
   htmlise(date("d/m/Y",strtotime($row->expiry)))
   :
  "Never"?></td>
<td><?=htmlise($row->validates_membership)?></td>
<td><?=htmlise($row->revokes_membership)?></td>
</tr>
<?php
}

} // if $member
?>
</tbody>
</table>
