<?php
$title = _("Edit Organisation Details");
headers(array('title'=>$title,'menu'=>1));

$user_member_id= get_member_id($_SESSION['user']);

global $dbh;
$result = $dbh->query("select * from orgs where id="
		      .$dbh->quote($_GET['id']));

$org = $result->fetchrow(DB_FETCHMODE_OBJECT);


if($_GET['id']
   && (has_permission($user_member_id,'edit orgs')
       || $org->owner_member_id==$user_member_id)
   ) {
  $can_edit= 1;
} else {
?>
  <div class="error">
    <p><?=_('You do not have adequate permissions to edit the details of this organisation.')?></p>
  </div>
<?php
  $can_edit= 0;
}

$form_editorg= array(
  'first_name'=> array('label'   =>_('Name'),
		       'type'    =>'text',
		       'required'=>1,
		       'default' =>$org->name,
		       'maxlength'=>50,
		       'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Must enter a name')
					  ),
		       ),
  'address1'   =>array('label'   =>_('Address 1'),
		       'type'    =>'text',
		       'required'=> true,
		       'maxlength'=>100,
		       'default' =>$org->address1,
		       'valid'   => array(
					  'preg_match("/\w{2,}/", $val)' =>
					  _('Your address must contain at least two letters.'),
					  ),
		       ),
  'address2'   =>array('label'   =>_('Address 2'),
		       'type'    =>'text',
		       'maxlength'=>100,
		       'default' =>$org->address2,
		       ),
  'suburb'     =>array('label'   =>_('Suburb'),
		       'type'    =>'text',
		       'required'=>true,
		       'default' =>$org->suburb,
		       'maxlength'=>50,
		       'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Must enter a suburb')
					  ),
		       ),
  'postcode'   =>array('label'   =>_('Postcode'),
		       'type'    =>'text',
		       'required'=>true,
		       'default' =>$org->postcode,
		       'maxlength'=>10,
		       'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Must enter a postcode')
					  ),
		       ),
  'state'      =>array('label'   =>_('State'),
		       'type'    =>'text',
		       'default' =>$org->state,
		       'maxlength'=>50,
		       ),
  'country'    =>array('label'   =>_('Country'),
		       'type'    =>'text',
		       'required'=>true,
		       'default' =>$org->country,
		       'maxlength'=>50,
		       'valid'   =>array(
					 'preg_match("/\w+/", $val)'
					 =>_('Must enter a country')
					 ),
		       ),
  'email'      =>array('label'   =>_('Email Address'),
		       'type'    =>'text',
		       'required'=>true,
		       'maxlength'=>100,
		       'default' =>$org->email,
		       'valid'   =>array(
					 'preg_match("/\w+/", $val)'
					 =>_('Must enter an email address')
					 ),
		       ),
  'website'      =>array('label'   =>_('Website'),
		       'type'    =>'text',
		       'maxlength'=>100,
		       'default' =>$org->website,
		       'valid'   =>array(
					 'preg_match("/^http:\/\//", $val)'
					 =>_('Must start with http://')
					 ),
		       ),
  'phone' =>array('label'   =>_('Phone'),
		       'type'    =>'text',
		       'default' =>$org->phone,
		       'maxlength'=>50,
		       ),
  'fax' =>array('label'   =>_('Fax'),
		       'type'    =>'text',
		       'default' =>$org->fax,
		       'maxlength'=>50,
		       ),
  'mobile'=>array('label'  =>_('Mobile Phone'),
			'type'   =>'text',
			'default'  =>$org->mobile,
			'maxlength'=>25,
			),
  'description'=>array('type'=>'textarea',
		       'label'=>_('Description'),
		       'title'=>_('Description of this organisation'),
		       'rows'=>5,
		       'cols'=>40,
		       'default'=> $org->description,
		       ),
  );

$errors = validate($form_editorg, $_POST);
if(!$errors && isset($_POST['edit_org'])) {

}
else
{
  echo '<div class="stdform">';
  echo '<h2>'._('Edit Organisation').'</h2>';
  print $errors;
  output_form($form_editorg,"edit_org",_("Apply"),"post","&id=".urlencode($_GET['id']));
  echo '</div>';
}
