<?php
$title = _("Edit Site Messages");
headers(array('title'=>$title,'menu'=>1));

if(!has_permission(get_member_id($_SESSION['user']),'edit site-message')) {
  ?>
<div class="error">
    <p><?=_('You do not have permission to do this.')?></p>
					 </div>
					 <?php
					 exit();
}

if(!$_GET['edit']) {
  // show list of site messages
?>
  <h2><?=_('Select message to edit')?></h2>
    <ul>
    <li><?=_('Membership Application')?>
    <ul>
    <li><a href="?page=edit-site-message&edit=signup/application-request-for-confirm"><?=_('Message sent to member requesting confirmation of their application')?></a></li>
    <li><a href="?page=edit-site-message&edit=signup/confirm-application"><?=_('Message sent to member after they have confirmed their application')?></a></li>
    <li><a href="?page=edit-site-message&edit=signup/approve-status-change"><?=_('Message sent after their application has been approved (or disapproved)')?></a></li>
    </ul>
    </li>
    <li><a href="?page=edit-site-message&edit=recover-password"><?=_('Recover Password')?></a></li>
    <li><?=_('Election')?>
    <ul>
    <li><a href="?page=edit-site-message&edit=election-notify-nominee"><?=_('Notify nominee of nomination.')?></a></li>
    <li><a href="?page=edit-site-message&edit=election-notify-nominator"><?=_('Notify nominator of their nomination')?></a></li>
    <li><a href="?page=edit-site-message&edit=election-notify-candidate"><?=_('Notify candidate that they have enough nominations.')?></a></li>
    <li><a href="?page=edit-site-message&edit=election-notify-candidate-nominator"><?=_('Notify nominator of candidate who now has enough nominations')?></a></li>
    <li><a href="?page=edit-site-message&edit=election-vote"><?=_('Notify voter that they have voted')?></a></li>
    </ul>
    </li>
    </ul>
<?php
    } else {
  $sql= "select * from site_messages where name=".$dbh->quote($_GET['edit']);
  $result= $dbh->query($sql);
  if(!DB::isError($result))
    $row = $result->fetchrow(DB_FETCHMODE_OBJECT);
  else
   {
     my_syslog(LOG_INFO,'site_messages: '.$result->getMessage());
     my_syslog(LOG_INFO,'site_Messages result: '.var_export($result,true));
   }

  $HTTP_POST_VARS['mail_to']= $row->mail_to;
  $HTTP_POST_VARS['mail_cc']= $row->mail_cc;
  $HTTP_POST_VARS['mail_subject']= $row->mail_subject;
  $HTTP_POST_VARS['message']= $row->message;

  echo '<h2>'._('Edit Email').'</h2>';
  // we have a message to edit
  $fields = array('fieldset'=>array('type'=>'fieldset',
				    'legend'=>_('Email'),
				    'fields'=>array(
		  'mail_to'=>array('type'=>'text',
				   'label'=>_('To'),
				   'required'=>1,
				   'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Enter To addresses')
					  ),
				   ),
		  'mail_cc'=>array('type'=>'text',
				   'label'=>_('Cc'),
				   'required'=>0,
				   ),
		  'mail_subject'=>array('type'=>'text',
					'label'=>_('Subject'),
					'required'=>1,
					'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Enter email subject')
					  ),
					),
		  'message'=>array('type'=>'textarea',
				   'label'=>_('Message'),
				   'cols'=>40,
				   'rows'=>10,
				   'required'=>1,
				   'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Enter message')
					  ),
				   ),
		  ),
				    )
		  );

		  echo '<div class="stdform">';

		  $errors = validate($fields, $HTTP_POST_VARS);

if(!$errors && strtolower($_SERVER['REQUEST_METHOD']) == 'post'
   && $_POST['edit-site-message']==_('Apply')) {
  my_syslog(LOG_DEBUG,"site_messages post: ".var_export($_POST,true));
  $dbh->query('begin');
  $sql='DELETE from site_messages where name='.$dbh->quote($_GET['edit']);
  $result= $dbh->query($sql);
  if(DB::isError($result)) {
    echo '<p>'._('Delete of existing record failed.').'</p>';
    my_syslog(LOG_INFO,'site_messages delete: '.var_export($result,true));
  } else {
    $sql= "insert into site_messages ";
    $sql.="(name,mail_to,mail_cc,mail_subject,message) values";
    $sql.="(".$dbh->quote($_GET['edit']).',';
    $sql.=$dbh->quote($_POST['mail_to']).',';
    $sql.=$dbh->quote($_POST['mail_cc']).',';
    $sql.=$dbh->quote($_POST['mail_subject']).',';
    $sql.=$dbh->quote($_POST['message']).')';

    my_syslog(LOG_DEBUG,"site_messages insert: $sql");
    $result= $dbh->query($sql);
    if(!DB::isError($result)) {
      $result= $dbh->query('commit');
      if(!DB::isError($result))
	echo '<p>'._('Updated Successfully.').'</p>';
      else
	echo '<p>'._('Error committing transaction.').'</p>';
    } else {
      my_syslog(LOG_INFO,'site_messages: '.$result->getMessage());
      my_syslog(LOG_INFO,'site_Messages result: '.var_export($result,true));
      echo '<p>'._('Failure updating database.').'</p>';
    }
  }
} else {
  print $errors;
  output_form($fields,"edit-site-message",_("Apply"),"post",
	      "&edit=".$_GET['edit']);
}
echo '</div>';

    }

?>