<?php
$title = _("Nominate");
headers(array('title'=>$title,'menu'=>1));

if(!$_GET['id']) {
  echo '<p class="error">'._('No Election Position ID specified.').'</p>';
  exit(0);
}

require_once 'backend/election.inc';

$positionrow = sql_select1("election_position","election_id",
			  "id=".$dbh->quote($_GET['id']));

$election = get_election($positionrow->election_id);

$nomination_cnt = sql_select1("election_candidate_nomination",
			  "count(*) as cnt",
			  "election_position_id=".$dbh->quote($_GET['id']).
			  " and for_member_id=".
			  $dbh->quote(get_member_id($_SESSION['user'])));

if($nomination_cnt->cnt < $election['num_req_nominations']) {
  echo '<p class="error">'
    ._('Not enough nominations for this position.')
    .'</p>';
  exit(0);
}

if($election['nominations-status']!='open') {
  echo '<p class="error">'
    ._('Election nominations are closed. You can no longer accept the nomination.')
    .'</p>';
  exit(0);
}


$new_candidate_form = array(
			    'spiel'=>array('type'=>'textarea',
					   'label'=>_('Spiel'),
					   'cols'=>40,
					   'rows'=>5,
					   )
			    );

$errors = validate($new_candidate_form, $_POST);

?>
<?php
$sql= "select election_position_id from election_candidate where election_position_id=".
	$dbh->quote($_GET['id'])." and member_id=".
	$dbh->quote(get_member_id($_SESSION['user']));
  $result = $dbh->query($sql);
  if(DB::isError($result)) {
    echo '<p class="error">'
      ._('Error checking acceptance of nomination.')
      .'</p>';
    my_syslog(LOG_ERR,'election-new-candidate: '.var_export($result,true));
  }
$already_accepted= 0;
if($result->numRows())
{
$already_accepted= 1;
}
if(!$already_accepted && ($errors || !isset($_POST['new_candidate']))) {
?>
  <h2><?=_('Accept Nomination')?></h2>
    <p><?=_('You are about to accept a nomination for a position.')?></p>

<dl>
    <dt><?=('Election')?></dt>
<dd><?=$election['name']?></dd>
    <dt><?=_('Position')?></dt>
<dd><?=$election['position'][$_GET['id']]['name']?></dd>
</dl>

<?php

  echo '<div class="stdform">';
  print $errors;
  output_form($new_candidate_form,"new_candidate",_("Accept"),"post",
	      "&id=".$_GET['id']);
  echo '</div>';
} else if(!$already_accepted) {
  $sql = "insert into election_candidate (election_position_id,member_id,spiel)"
    ." values ("
    .$dbh->quote($_GET['id']).", "
    .$dbh->quote(get_member_id($_SESSION['user'])).", "
    .$dbh->quote($_POST['spiel']).")";
  $result = $dbh->query($sql);
  if(DB::isError($result)) {
    echo '<p class="error">'
      ._('Error submitting acceptance of nomination.')
      .'</p>';
    my_syslog(LOG_ERR,'election-new-candidate: '.var_export($result,true));
    if($result->getCode()==DB_ERROR_ALREADY_EXISTS
       && strstr($result->getUserInfo(),'election_candidate_pkey')
       ) {
      echo '<p class="error">'
	._('You have already accepted this nomination.')
	.'</p>';
    }
  } else {
?>

<h2><?=_('Accepted Nomination')?></h2>
<p><?=_('You have accepted the nomination.')?></p>
<dl>
      <dt><?=_('Election')?></dt>
      <dd><?=$election['name']?></dd>
      <dt><?=_('Position')?></dt>
      <dd><?=$election['position'][$_GET['id']]['name']?></dd>
</dl>

<?php
   }
} else {
?>
  <h2><?=_('Previously Accepted Nomination')?></h2>
    <p><?=_('You have previously accepted this nomination. Spiels cannot be edited.')?></p>
<dl>
    <dt><?=_('Election')?></dt>
<dd><?=$election['name']?></dd>
    <dt><?=_('Position')?></dt>
<dd><?=$election['position'][$_GET['id']]['name']?></dd>
</dl>

<?php
}
?>
