<?php
$title = _("Nominate");
headers(array('title'=>$title,'menu'=>1,
	      'head_extras'=>'<script type="text/javascript" src="lib/popupcalendar/calendar.js"></script>',
	      )
	);

if(has_permission(get_member_id($_SESSION['user']),'edit positions'))
  $can_edit = 1;

if(!$_GET['id']) {
  echo '<p class="error">'._('No Election ID specified.').'</p>';
  exit(0);
}

require_once 'backend/election.inc';

$election = get_election($_GET['id']);

if($election['nominations-status']!='open') {
  echo '<p class="error">'._('Election nominations are closed.').'</p>';
  exit(0);
}

foreach($election['position'] as $i => $p) {
  $pos[$i] = $p['name'];
}

$nominateform = array('set'=>array('type'=>'fieldset',
				   'legend'=>_('Nomination'),
				   'fields'=>array(
		      'position'=>array('type'=>'select',
					'label'=>_('Position'),
					'items'=>$pos
					),
		      'member'=>array('type'=>'text',
				      'label'=>_('Email address of Nominee'),
				      'required'=>1,
				      'valid'=>array(
						     '$id = get_member_id($val); if(!$id) return false; $m=get_member($id); if($m->email!=$val) return false; return true;'=>_('The email address must be that of a current member of the organisation. You may want to check with the person that this email address is the one they registered with.')
						     ),
				      ),
		      'reason'=>array('type'=>'textarea',
				      'label'=>_('Reason (optional)'),
				      'cols'=>40,
				      'rows'=>5),
		      ),
				   ),
		      );

$errors = validate($nominateform, $_POST);

?>
<h2><?=_('Nominate')?></h2>
<h3><?=$election['name']?></h3>
<p><?=$election['desc']?></p>
<?php
if($errors || !isset($_POST['nominate'])) {
  echo '<div class="stdform">';
  print $errors;
  output_form($nominateform,"nominate","Nominate","post",
	      "&id=".urlencode($_GET['id']));
  echo '</div>';
} else {
  // We have a nomination!
  $result = sql_insert('election_candidate_nomination',
		 array(
		       'election_position_id'=>$_POST['position'],
		       'from_member_id'=>get_member_id($_SESSION['user']),
		       'for_member_id'=>get_member_id($_POST['member']),
		       'reason'=>$_POST['reason'],
		       ),
		       0
		       );
  if(DB::isError($result)) {
    echo '<p class="error">'._('Error submitting nomination.').'</p>';
    if($result->getCode()==DB_ERROR_ALREADY_EXISTS) {
      echo '<p class="error">'._('You have already nominated this person for this position.').'</p>';
    }
  } else {
    echo '<p>'._('Your nomination has been recorded.').'</p>';
    echo '<p>'.$_POST['member'].' for '.$pos[$_POST['position']].'</p>';

    $sql = "select count(*) as cnt from election_candidate_nomination where"
      ." election_position_id=".$dbh->quote($_POST['position'])." and "
      ." for_member_id=".$dbh->quote(get_member_id($_POST['member']));
my_syslog(LOG_INFO,$sql);
    $result = $dbh->query($sql);
    $row = $result->fetchrow(DB_FETCHMODE_OBJECT);

    $messagevars= array('MEMBER_EMAIL'=>$_SESSION['user'],
			'ORG_NAME'=>$org->name,
			'ORG_URL'=>$org->website,
			'MEMBERSHIP_ADMIN'=>$config['membership-admin'],
			'DATE'=>date('Y-m-d H:i:s'),
			'NOMINEE_EMAIL'=>$_POST['member'],
			'NOMINEE'=>$_POST['member'],
			'ELECTION'=>$election['name'],
			'POSITION'=>$pos[$_POST['position']],
			'NOMINATOR'=>$_SESSION['user'],
			'ACTION_URL'=>$config['baseurl']."?page=election-new-candidate&id=".urlencode($_POST['position']),
			);

    if($row->cnt >= $election['num_req_nominations'])
      site_message('election-notify-candidate', $messagevars);
    else
      site_message('election-notify-nominee', $messagevars);
  }
  echo '<p><a href="?page=view-election&id='.$_GET['id'].'">'
    ._('View Election')
    .'</a>';
  echo '</p>';
}
?>
