<?php
$title = $config['index_title'];
headers(array('title'=>$title, 'menu'=>1,
	      'head_extras'=>'<script type="text/javascript" src="lib/sorttable.js"></script>',
	      )
	);

$sql= "SELECT election_position.id AS election_position_id, "
     ."       election.id AS election_id, "
     ."       election.name AS election_name, "
     ."       election_position.name AS position "
     ."FROM "
     ."       election_position"
     ."  JOIN election "
     ."    ON election_position.election_id = election.id "
     ."WHERE  election_position.id "
     ."    IN (SELECT DISTINCT election_position_id"
     ."        FROM election_candidate_nomination"
     ."        WHERE for_member_id=".
                   $dbh->quote(get_member_id($_SESSION['user']))
     ."        AND election_position_id "
     ."            IN (SELECT election_position.id "
     ."                FROM election_position "
     ."                WHERE election_id IN (SELECT election.id "
     ."                                      FROM election "
     ."                                      WHERE nominations_close > now())"
     ."               )"
     ."       )";

$result = $dbh->query($sql);

if (PEAR::isError($result)) {
    my_syslog(LOG_ERR, $result->getMessage());
    my_syslog(LOG_ERR, $sql);
    die ("Error while querying database, has been logged.");
}

if($result->numRows())
{
?>
  <h2><?=_('Election Nominations')?></h2>
<table class="sortable" id="election_nominations">
<thead>
<tr>
    <th><?=_('Election')?></th>
    <th><?=_('Position')?></th>
    <th><?=_('Action')?></th>
</tr>
</thead>
<tbody>
<?php
   while($row= $result->fetchrow(DB_FETCHMODE_OBJECT))
   {
     ?>
<tr>
  <td><a href="?page=view-election&id=<?=$row->election_id?>">
     <?=htmlise($row->election_name)?>
     </a>
  </td>
  <td><?=htmlise($row->position)?></td>
  <td><a href="?page=election-new-candidate&id=<?=urlencode($row->election_position_id)?>">Accept</a>
  </td>
</tr>
     
     <?php
   }
?>
</tbody>
</table>
<?php
}

include $config['basedir'].'/site-look/index.inc';
?>
