<?php

$title = _("Change Password");
headers(array('title'=>$title,'menu'=>1));

$fields= array('function'=>array('type'=>'hidden',
				 'value'=>'passwd'),
	       'password'=>array('type'=>'password',
				 'label'=>_('Current Password'),
				 'required'=>1,
				 'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Enter current password'),
					  'login($_SESSION["user"],$_POST["password"])'
					  =>_('Incorrect password')
					  ),
				 ),
	       'newpass1'=>array('type'=>'password',
				 'label'=>_('New Password'),
				 'required'=>1,
				 'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Enter new password')
					  ),
				 ),
	       'newpass2'=>array('type'=>'password',
				 'label'=>_('New Password (Confirm)'),
				 'required'=>1,
				 'valid'   => array(
					  'preg_match("/\w+/", $val)'
					  =>_('Enter new password to confirm'),
					  '$_POST["newpass1"]==$_POST["newpass2"]'=>
					  _("New Passwords don't match")
					  ),
				 ),
	       );

echo '<div class="stdform">';

echo '<h2>'._('Change Password').'</h2>';

$errors = validate($fields, $HTTP_POST_VARS);

if(!$errors
   and strtolower($_SERVER['REQUEST_METHOD']) == 'post'
   and isset($_POST['passwd'])) {

  /* Correct current password, both passwords match */
  $salt = randomString(rand(1,10));
  $md5pass = md5($salt.$_POST['newpass1']);
  
  $sql = "update passwd set salt=".$dbh->quote($salt)
    .", password=".$dbh->quote($md5pass)." where member_id="
    .$dbh->quote(get_member_id($_SESSION['user']));
  
  $result = $dbh->query($sql);
  if (DB::isError($result)) {
    my_syslog(LOG_INFO,$result->getMessage());
    echo '<p class="error">'._('Database error, password not changed.').'</p>';
  } else {
    echo '<p>'._('Password Changed').'</p>';
  }

} else {
  print $errors;
  output_form($fields,"passwd",
	      _("Change Password"),"post",'');
}

echo '</div>';

?>
