<?php

function get_election($id) {
  // Get info on the election
  global $dbh;

  $row = sql_select('election','id='.$dbh->quote($id));
  $election['id'] = $row->id;
  $election['name'] = $row->name;
  $election['desc'] = $row->description;
  $election['num_req_nominations'] = $row->num_req_nominations;
  $election['start_advertising'] = date("d/m/Y H:i",
					strtotime($row->start_advertising));
  $election['start_nominations'] = date("d/m/Y H:i",
					strtotime($row->nominations_start));
  $election['close_nominations'] = date("d/m/Y H:i",
					strtotime($row->nominations_close));
  $election['advertise_candidates'] = date("d/m/Y H:i",
					   strtotime($row->advertise_candidates));
  $election['live_results'] = $row->live_results;
  $election['start_voting'] = date("d/m/Y H:i",strtotime($row->start_voting));
  $election['close_voting'] = date("d/m/Y H:i",strtotime($row->close_voting));
  $election['show_results'] = date("d/m/Y H:i",strtotime($row->show_results));
  
  $electionrow = $row;
  if(time() >= strtotime($electionrow->start_advertising))
    $election['advertise']='visible';
  else
    $election['advertise']='not visible';

  if(time() > strtotime($electionrow->advertise_candidates))
    $election['advertise_candidates-status']='visible';
  else
    $election['advertise_candidates-status']='not yet visible';

  if(time() > strtotime($electionrow->nominations_start)
     && time() < strtotime($electionrow->nominations_close)) {
    $election['nominations-status'] = 'open';
  } else {
    $election['nominations-status'] = 'closed';
  }

  if(time() > strtotime($electionrow->start_voting)
     && time() < strtotime($electionrow->close_voting)) {
    $election['voting'] = 'open';
  } else {
    $election['voting'] = 'closed';
  }
  
  if(time() > strtotime($electionrow->show_results))
    $election['results'] = 'available';
  else
    $election['results'] = 'not available';


  $sql = "select * from election_position where election_id=".
    $dbh->quote($id);
  $result = $dbh->query($sql);
  for($i=0;$row = $result->fetchrow(DB_FETCHMODE_OBJECT);$i++) {
    $election['position'][$row->id]['name'] = $row->name;
    $election['position'][$row->id]['num'] = $row->num;
    $election['position'][$row->id]['desc'] = $row->description;
  }
  $election['nrpositions']=$i;

  $sql = "select * from election_candidate_nomination where election_position_id in (select id from election_position where election_id=".$election['id'].");";
  $election['nominations'] =& $dbh->getAll($sql,array(),DB_FETCHMODE_ASSOC);
  
  $sql = "select election_candidate.id as id,"
    ." election_candidate.election_position_id as election_position_id,"
    ." election_candidate.member_id as member_id,"
    ." election_candidate.spiel as spiel"
    ." from election_candidate,election_position where"
    ." election_position.id = election_candidate.election_position_id"
    ." and election_position.election_id=".$election['id']
    ." order by election_position_id";
  $election['candidates'] =& $dbh->getAll($sql,array(),DB_FETCHMODE_ASSOC);

  return $election;
}

/**
 * Make a list of possibly rank positions for this position.
 */
function election_make_rank_list( $position_id, $candidate_list ) {

  $num_candidates = 0;

  foreach( $candidate_list as $c )
    if( $c['election_position_id'] == $position_id )
      $num_candidates++;

  $rankings = array( '' => 'Choose&hellip;' );

  for( $i = 1; $i <= $num_candidates; $i++ ) {
    $rankings[$i] = "&nbsp;&nbsp;Preference $i";
  }
  $rankings['0'] = '&nbsp;&nbsp;No preference';
  return $rankings;
}



?>
