<?php
/*
 * forms.inc.php
 * -------------
 *
 * Based heavily on Owen's code.
 *
 * (C)2004-2005 Stewart Smith
 * (C)2004 Owen Rodda
 */


function radiolist($name, $setup) {
  echo $setup['html'];
  $n = 1;
  echo "<div class=\"radiolist\">\n";
  foreach($setup['options'] as $what) {
    echo "<p><label for=\"$name$n\">$what</label>";
    echo '<input type="radio" id="'.$name.$n.'" name="'.$name;
    echo '" value="'.$what.'" ';
    if($setup['value'] == $what) {
      echo ' checked="checked"';
    }
    echo "/></p>\n";
    $n++;
  }
  echo "</div>\n";
}

function field_button($name,$setup) {
  echo '<input type="Submit" name="'.$name.'" value="'.$setup['label'].'"/>';
}

function field_phone($name,$setup) {
  echo "(<input type=\"text\" name=\"$name-area\" id=\"$name\" size=\"4\" maxlength=\"5\" value=\"{$setup['area']}\" />) ";
  echo "<input type=\"text\" id=\"$name-phone\" name=\"$name\" ";
  if(isset($setup['maxlength'])) {
    echo "maxlength=\"{$setup['maxlength']}\" ";
  }
  echo "value=\"{$setup['phone']}\" />";
}

function field_text($name,$setup) {
  echo "<input type=\"text\" id=\"$name\" name=\"$name\" ";
  if(isset($setup['maxlength'])) {
    echo "maxlength=\"{$setup['maxlength']}\" ";
  }
  echo "value=\"{$setup['value']}\" />";
}

function field_password($name,$setup) {
  echo "<input type=\"password\" id=\"$name\" name=\"$name\" ";
  if(isset($setup['maxlength'])) {
    echo "maxlength=\"{$setup['maxlength']}\" ";
  }
  echo "value=\"{$setup['value']}\" />";
}

function field_textarea($name,$setup) {
  echo '<textarea id="'.$name.'" name="'.$name.'"';
  if(isset($setup['rows']))
    echo ' rows="'.$setup['rows'].'"';
  if(isset($setup['cols']))
    echo ' cols="'.$setup['cols'].'"';
  if(isset($setup['title']))
    echo ' title="'.$setup['title'].'"';
  if(isset($setup['wrap']))
    echo ' wrap="'.$setup['wrap'].'"';
  else
    echo ' wrap="physical"';
  echo '>';
  echo $setup['value'];
  echo '</textarea>';
}

function field_hidden($name,$setup) {
  echo "<input type=\"hidden\" id=\"$name\" name=\"$name\" ";
  echo "value=\"{$setup['value']}\" />";
}

function field_date($name,$setup,$formname) {
  echo "<input type=\"text\" id=\"$name\" name=\"$name\" ";
  if(isset($setup['maxlength'])) {
    echo "maxlength=\"{$setup['maxlength']}\" ";
  }
  echo "value=\"{$setup['value']}\"/>";
  echo '<a href="javascript: void(0);" onclick="return getCalendar(document.forms.'.$formname.'.'.$name.');"><img src="lib/popupcalendar/calendar.png" border="0" /></a>';
}

function field_select($name,$setup) {
  echo "<select name=\"$name\" id=\"$name\">\n";
  if(isset($setup['options'])) {
    foreach($setup['options'] as $option) {
      echo "<option";
      
      if($setup['value'] == $option) {
	echo " selected=\"selected\"";
      }
      echo ">$option</option>\n";
    }
  } else {
    foreach($setup['items'] as $value => $text) {
      echo "<option value=\"$value\"";
      if($value && ($setup['value'] == $value)) {
	echo " selected=\"selected\"";
      }
      echo ">$text</option>\n";
    }
  }
  echo "</select>";
}

function field_checkbox($name,$setup) {
  echo '<input type="checkbox" id="'.$name.'" name="'.$name.'" ';
  echo 'title="'.$setup['value'].'" ';
  if($setup['checked']) {
    echo 'checked="yes" ';
  }
  echo '/>';
}

function output_field(&$name, &$setup,$formname) {
  switch($setup['type']) {
  case 'custom':
    eval($setup['output'] . '($name, $setup);');
    return;
  case 'html':
    echo $setup['html'];
    return;
  case 'hidden':
    field_hidden($name,$setup);
    return;
  case 'button':
    field_button($name,$setup);
    return;
  case 'calculated':
    return;
  case 'fieldset':
    echo '<fieldset><legend>'.$setup['legend'].'</legend>';
    foreach(array_keys($setup['fields']) as $fieldname)
      output_field($fieldname, $setup['fields'][$fieldname],$formname);
    echo '</fieldset>';
    return;
  }

  if(!isset($setup['value']) && isset($setup['default']))
    $setup['value']=$setup['default'];

  if(isset($setup['error']))
    echo "<div class=\"error\">";

  echo "<p class=\"field\">";
  if($setup['type']!='checkbox') {// checkbox has label *AFTER* the field
    echo "<label for=\"$name\">{$setup['label']}";
    if(isset($setup['required']))
      echo " <span class=\"mandatory\">*</span>";
    echo "</label>";
  }

  switch($setup['type']) {
  case 'phone':
    field_phone($name,$setup);
    break;
  case 'text':
    field_text($name,$setup);
    break;
  case 'password':
    field_password($name,$setup);
    break;
  case 'textarea':
    field_textarea($name,$setup);
    break;
  case 'date':
    field_date($name,$setup,$formname);
    break;
  case 'select':
    field_select($name,$setup);
    break;
  case 'checkbox':
    field_checkbox($name,$setup);
    // we have our own label *AFTER* the checkbox
    echo "<label for=\"$name\">{$setup['label']}";
    if(isset($setup['required']))
      echo " <span class=\"mandatory\">*</span>";
    echo "</label>";
    
    break;
  case 'html': // pseudo form type for embedding HTML
    echo $setup['html'];
    break;
  default:
    echo "<strong>Unrecognised field type</strong>";
  }
  if(isset($setup['note']) && !isset($setup['error']))
    echo "<br />{$setup['note']}";
  echo "</p>\n";
  if(isset($setup['error']))
    echo "<p><img src=\"images/error.png\" width=\"16\" height=\"16\" alt=\"Error:\" /> {$setup['error']}</p></div>\n";
}

function output_form(&$fields, $formname="stdform",$submit="Submit", $method="post", $query='') {
  echo "<form action=\"{$_SERVER['PHP_SELF']}?page={$_GET['page']}$query\" method=\"$method\" id=\"$formname\">\n";
  foreach(array_keys($fields) as $fieldname)
    output_field($fieldname, $fields[$fieldname],$formname);
  echo "<p class=\"submit\"><input type=\"submit\" name=\"$formname\" value=\"$submit\" /></p>\n";
  echo "</form>\n";
}

function format_errorlist($el) {
  return "<div class=\"error\">\n<p><img src=\"images/error.png\" width=\"16\" height=\"16\" alt=\"Error:\" /> Your answers contained some errors. Please check the following and try again:</p>\n<ul><li>" . join("</li>\n<li>", $el) . "</li>\n</ul>\n<p>Explanations for these errors are provided below the relevant fields.</p></div>\n";
}
function validate(&$fields, &$source,$formaterrlist=1) {
  $errorlist = array();
  foreach(array_keys($fields) as $field) {
    $values = &$fields[$field];
    if($values['type']=='fieldset') {
      $newlist = validate($values['fields'],$source,0);
      if($newlist)
	$errorlist+=$newlist;
      next;
    }
    
    if(!isset($source[$field])) {
      if(!isset($values['default'])) {
	$values['default'] = '';
      }
      $fields[$field]['value'] = htmlentities($values['default']);
      if($values['type'] == 'phone') {
	preg_match('/^(\d*)-?(\d*)$/', $values['default'], $m);
	$fields[$field]['area'] = $m[1];
	$fields[$field]['phone'] = $m[2];
      }
    } else {
      $val = $source[$field];
      if($values['type'] == 'phone') {
	$fields[$field]['area'] = preg_replace('/\D/', '', $source["$field-area"]);
	$fields[$field]['phone'] = preg_replace('/\D/', '', $source["$field"]);
	$val =  $fields[$field]['area']. '-' . $fields[$field]['phone'];
      }
      $fields[$field]['value'] = htmlentities(get_magic_quotes_gpc()?
					      stripslashes($source[$field])
					      :$source[$field]);
      if(isset($values['valid'])) {
	if($values['type'] == 'date') {
	  // americanise
	  $aval = preg_replace('|\s*\b(\d\d?)\s*[./\-\s]\s*(\d\d?)\b\s*|', '$2/$1', $val);
	  $aval = preg_replace('|(\d{1,2})[.\-\/](\d{1,2})[.\-\/](\d{2,4})|', '$1/$2/$3', $aval);
	  $aval = preg_replace('|(\d{4})[.\-\/](\d{1,2})[.\-\/](\d{1,2})|', '$1-$3-$2', $aval);
	  $date = @strtotime($aval);
	  
	} else {
	  unset($date);
	}
	foreach($values['valid'] as $test => $error) {
	  $result = false;
 	  if(strstr($test,'return'))
 	    $result = eval($test);
 	  else
 	    eval('$result = (' . $test . ');');
	  if(!$result) {
	    $errorlist[] = $values['label'];
	    $fields[$field]['error'] = $error;
	    break;
	  }
	}
      }
      if($values['type'] == 'date' and !isset($fields[$field]['error']) and isset($values['format'])) {
	$fields[$field]['value'] = date($values['format'], $date);
      }
    }
  }
  if(count($errorlist)) {
    if($formaterrlist)
      return format_errorlist($errorlist);
    else
      return $errorlist;
  } else return false;
}


?>
