<?php
/**
 * Confirm Membership
 * 
 * This function is called after a user receives
 * an email requesting them to confirm their membership
 * (i.e. that their email address is valid)
 *
 * AUDIT: 20041125 (stewart) - check input/output processing
 *
 * @package functions/confirm_membership
 * @author (C)2003 Stewart Smith.
 * 
 * Licensed under the GPL.
 *
 */

// we +0 to get an integer, this way we don't have to dbh->quote
// to remove any security threat.
$id = $_GET['id']+0; // id is parameter, using GET method

$already_confirmed= 0;
if(get_member($id)) {
 $already_confirmed= 1;
}

$row = sql_select1("org_members","count(*) as c","member_type_id=(select id from member_types where type='Pending') and member_id=$id");
if($row->c > 0) {
 $already_confirmed= 1;
}

$sql = "select members.id as id from members,org_members where ".
       "org_members.org_id=".$config['org_id']." and ".
       "members.id = org_members.member_id and ".
       "org_members.member_type_id = (select id from member_types where type='Applied') and members.id = ".$id;

my_syslog(LOG_DEBUG,$sql);
$result = $dbh->query($sql);

if($already_confirmed) {
  $message = "Already confirmed";
}
else if (DB::isError($result)) {
  my_syslog(LOG_INFO,"1 ".$result->getMessage());
  $message = 'Cannot confirm this ID';
}
else
{
  $row =  $result->fetchrow(DB_FETCHMODE_OBJECT);
  my_syslog(LOG_DEBUG,"About to change ".$row->id." to Pending ($id) (".($row->id==$id).")");
  if($row->id==$id)
    {
      $sql = 'insert into org_members (org_id,member_id,member_type_id,start_date,expiry) values ('.$config['org_id'].','.$id.",(select id from member_types where type='Pending'),now(),DATE_ADD(now(),INTERVAL 1 YEAR))";
      my_syslog(LOG_DEBUG,$sql);
      $result = $dbh->query($sql);
      if (DB::isError($result)) {
	my_syslog(LOG_INFO,$result->getMessage());
      }
      $sql = 'select * from members where id='.$id;
      $result = $dbh->query($sql);
      if (DB::isError($result)) {
	my_syslog(LOG_INFO,$result->getMessage());
      }
      $row = $result->fetchrow(DB_FETCHMODE_OBJECT);

      $messagevars= array('ORG_NAME'=>$org->name,
			  'ORG_URL'=>$org->website,
			  'MEMBERSHIP_ADMIN'=>$config['membership-admin'],
			  'MEMBER_FULLNAME'=>$row->first_name.' '.
			  $row->middle_name.' '.$row->last_name,
			  'MEMBER_ADDRESS'=>$row->address1."\n".
			  $row->address2."\n".
			  $row->suburb."  ".$row->postcode."\n".
			  $row->state."\n".
			  $row->country."\n",
			  'MEMBER_EMAIL'=>$row->email,
			  'DATE'=>date('l dS \of F Y h:i:s A')
			  );

      site_message('signup/confirm-application',$messagevars);
      $message = _('Confirmed Application');
    }
  else
    {
      my_syslog(LOG_DEBUG,"Cannot Confirm $id - $row->id");
      $message = _('Cannot confirm this ID');
    }
}
?>
