--
-- Data for `mail_queue_seq`
--

INSERT INTO mail_queue_seq (id) VALUES (1);


-- initial_data.sql
-- ----------------
--
-- The initial data required to bootstrap the memberdb system.
--
-- (C)2004 Stewart Smith
--
-- NOTE: You should customise this file for your own
--       organisation before running it!

insert into orgs (id,name,website,description)
	values (
	  1,
	  'MemberDB Organisation',
	  'http://www.flamingspork.com/projects/memberdb/',
	  'An organisation for all the cool people who run MemberDB'
	);

insert into members (id,
		first_name,
		email)
	values (
	  1,
	  'Admin',
	  'admin@localhost'
	);

insert into member_types (id,org_id,
			type,
			description,
			validates_membership,revokes_membership)
	values (
	  1,1,
	  'Member',
	  'Ordinary Member',
	  true,false
	);

insert into org_members (member_id,org_id,member_type_id,
			 start_date,expiry)
	values (
	  1,1,1,
	  now(),NULL
	);

insert into passwd (member_id,salt,password) values (1,'5',MD5('5pants'));

-- create_activities.sql
-- ---------------------
--
-- Activities required to grant permissions to.
-- This needs to be loaded for memberdb to work,
-- it's just kept seperate for easier diffing for updates
--
-- (C)2004 Stewart Smith

insert into activities (activity,description) values
	('admin',
	'Can administrate anything. Equivilent to root.');

insert into activities (activity,description) values
	('add org_members',
	 'Can add an entry into the org_members table. This '
	 'can be used for renewing memberships or accepting '
	 'membership applications.');

insert into activities (activity,description) values
	('edit org_members',
	 'Ability to change the details of members other than'
	 'yourself.'
	);

insert into activities (activity,description) values
	('list members',
	 'Ability to retrieve a list of current members of '
	 'an organisation.');

insert into activities (activity,description) values
	('edit positions',
	'Ability to edit the types of positions a member can hold');

insert into activities (activity,description) values
	('election admin',
	'Ability to administrate (create, edit) elections.');

--
-- Grant permission to the admin user
--

insert into permissions (member_id,org_id,activity_id,can_do,can_grant,start_datetime,end_datetime) values (1,1,(select id from activities where activity='admin'),true,true,now(),null);
