create table schema_version (version int);
insert into schema_version (version) values (5);

CREATE or replace view current_memberships AS
       select 
         members.*,
	  orgs.id as org_id,
	  orgs.name as org_name,
	  member_types.id as member_type_id,
	  member_types.type as member_type
       from members
       left join (orgs,org_members,member_types)
        on (org_members.member_id=members.id
	    AND org_members.member_type_id=member_types.id
	    and orgs.id=org_members.org_id
	    )
       where
         (org_members.expiry > now() or org_members.expiry is null)
	 and (org_members.start_date < now() or org_members.start_date is null)
	 and member_types.validates_membership=true
	 and not exists (select member_id from org_members
		        left join (member_types)
		        on org_members.member_type_id=member_types.id
			 where
			 org_members.member_id=members.id and 
         (org_members.expiry > now() or org_members.expiry is null)
	 and (org_members.start_date < now() or org_members.start_date is null)
	 and member_types.revokes_membership=true
	 );