<?php

/* Recover Password
 * ----------------
 *
 * Part of MemberDB
 *
 * (C) 2004-2005 Stewart Smith
 * Distributed under the GPL
 */

$title = _("Recover Password");
headers(array('title'=>$title,'menu'=>1));

$row = sql_select1("members","email","email=".$dbh->quote($_POST["email"]));

$fields = array(
  'email'      =>array('label'   =>_('Email Address'),
		       'type'    =>'text',
		       'required'=>true,
		       'valid'   =>array(
					 'preg_match("/\w+/", $val)'
					 =>_('Must enter an email address'),
					 '$val=="'.$row->email.'"'
					 =>_('No record was found of this address, possibly try another one?')
					 ),
		       )
  );

echo '<div class="stdform">';

include $config['basedir'].'/site-look/recover-password-form.inc';

$errors = validate($fields, $HTTP_POST_VARS);

if(!$errors and strtolower($_SERVER['REQUEST_METHOD']) == 'post') {
  $token = token_create(get_member_id($_POST['email']),'recover password');
  $time_to_live = '2 days';
  $messagevars= array('ORG_NAME'=>$org->name,
		      'ORG_URL'=>$org->website,
		      'MEMBERSHIP_ADMIN'=>$config['membership-admin'],
		      'DATE'=>'Now',
		      'MEMBER_EMAIL'=>$_POST['email'],
		      'ACTION_URL'=>$config['baseurl'].'?page=reset-password&token='.$token,
		      'ACTION_TTL'=>$time_to_live,
		      );

  site_message('recover-password', $messagevars);

  print "<h2>"._('Recover Password')."</h2>";
  print "<p>"._('An email has been sent to you with further instructions.')."</p>";
} else {
  print $errors;
  output_form($fields);
}

echo '</div>';

?>
